# Rust编程指南

[为何创作本书](why-another.md)
[关于Rust语言](into-rust.md)

## Getting started

- [牛刀小试](first-try/intro.md)
    - [安装Rust环境](first-try/installation.md)
    - [墙推VSCode!](first-try/editor.md)
    - [认识Cargo](first-try/cargo.md)
    - [你好，世界!](first-try/hello-world.md)

## Rust学习三部曲

- [基本概念](basic-concepts/intro.md)
    - [变量与类型](basic-concepts/variable-type.md)
    - [结构体、枚举](basic-concepts/struct-enum.md)
    - [函数与方法](basic-concepts/function-method.md)
    - [格式化输出](basic-concepts/formatted-output.md)
    - [字符串、数组与切片](basic-concepts/string-array-slice.md)
    - [流程控制](basic-concepts/flow-control.md)
    - [返回、异常和错误](basic-concepts/exception-error.md)
    - [模式匹配](basic-concepts/match-pattern.md)
    - [文档注释](basic-concepts/comment.md)
    - [包和模块](basic-concepts/crate-module.md)
    
- [核心概念](core-concepts/intro.md)
    - [所有权](core-concepts/ownership.md)
    - [借用](core-concepts/borrowing.md)
    - [生命周期](core-concepts/lifetime.md)
    
- [进阶编程](advanced-concepts/intro.md)
    - [泛型](advanced-concepts/generitic.md)
    - [特征](advanced-concepts/trait.md)
    - [迭代器](advanced-concepts/interator.md)
    - [集合类型](advanced-concepts/collection.md)
    - [函数式编程](advanced-concepts/functional-programing.md)
    - [智能指针](advanced-concepts/smart-pointer.md)
    - [多线程](advanced-concepts/threads.md)
    - [测试](advanced-concepts/tests.md)
    - [错误处理](advanced-concepts/errors.md)
    - [宏](advanced-concepts/macro.md)

## 专题内容

- [代码风格](style-guide/intro.md)
    - [命名规范](style-guide/naming.md)
- [面向对象](object-oriented/intro.md)
    - [OO所需的特性](object-oriented/characteristics.md)
- [异步编程](async/intro.md)
    - [并发与并行](async/concurrency-parallelism.md)
- [Cargo详解](cargo/intro.md)
    - [配置参数](cargo/manifest.md)
- [性能调优](performance/intro.md)
    - [Benchmark性能测试](performance/benchmark.md)
- [Unsafe](unsafe/intro.md)
    - [原始指针](unsafe/raw-pointer.md)

- [宏编程](macro/intro.md)
    - [过程宏](macro/procedure-macro.md)


## 场景模版

- [场景示例](use-case/intro.md)